import javax.sound.sampled.Port;
import javax.lang.model.element.Element;
import javax.print.DocFlavor.STRING;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

public class Poker {

    public String suit;
    public String values;
    public Poker(){
        values = "";
        suit = "";
    }
    public String getSuit(){
        return suit;
    }
    public String getValue(){
        return values;
    }
    //Metodo para cargar los valores y los palos
    public void setValues(String carta){
        values = ordenarCadena(values + String.valueOf(carta.charAt(0)));
        suit = ordenarCadena(suit + String.valueOf(carta.charAt(1)));
    }
    //Recibe un string y lo ordena segun orden numerico o alfabetico
    public String ordenarCadena(String original){
        String numeroAOrdenar = original;
        numeroAOrdenar = original;
        char[] chars = numeroAOrdenar.toCharArray();
        Arrays.sort(chars);
        String cadenaOrdenada = new String(chars);
        return cadenaOrdenada;
    }
    //***********CONTROLA LA JUGADA QUE SE DA EN LOS PALOS
    public String controlPalos(String palos){
        int contador = 0;
        for (int i = 0; i < palos.length(); i++) {
            for (int j = 0; j < palos.length(); j++) {
                if (palos.charAt(i) == palos.charAt(j)) {
                    contador++;
                }
            }
        }
        if (contador == 25) {
            return "COLOR";
        } else {
            //Para mejor manejo si no cumple ninguna de las condiciones envia una cadena vacia
            return "";
        }
    }
   //***********CONTROLA QUE JUGADA SE DA EN LOS VALORES
   public String controlValor(String valores){
    int contador = 0;
    int secuencial = 0;
    boolean thereIsLetter = false;
    for (int i = 0; i < valores.length(); i++) {
        for (int j = 0; j < valores.length(); j++) {
            if (valores.charAt(i) == valores.charAt(j)) {
                contador++;
            }
        }
    }
    if (contador < 6) {
        //controla que existan letras en los valores mandados
        for (int i = 0; i < valores.length(); i++) {
            String l = String.valueOf(valores.charAt(i));
            if (l == "T" || l == "J" || l == "Q" || l == "K" || l == "A") {
                thereIsLetter = true;
                break;
            }
        }
        //Una condicional para el caso que existan letras
        if(thereIsLetter == false){
            //Para mejor entendimiento visual lo guardo en una variable de nombre mas corto
            String v = getValue();
            if ( (v.equals("89JQT")) || (v.equals("9JKQT")) || ((v).equals("AJKQT")) ||(v.equals("2345A")) || (v.equals("789JT")) ||(v.equals("6789T"))){
                return "ESCALERA";
            }
        }else{
            for (int i = 1; i < valores.length(); i++) {
                if (Character.getNumericValue(valores.charAt(i)) == Character.getNumericValue(valores.charAt(i-1)) + 1) {
                        secuencial++;   
                }                
            }
            if (secuencial == 4) {
                return "ESCALERA";
            } 
        }   
    }else if (contador == 17) {
        return "POKER";
    }else if(contador == 13){
        return "FULL";
    }else if(contador == 11){
        return "TRIO";
    }else if(contador == 9){
        return "PAR DOBLE";
    }else if(contador == 7){
        return "PAR";
    }
    //Para mejor manejo si no cumple ninguna de las condiciones envia una cadena vacia
    return "";
}
    // este es el único método que tienen que desarrollar
    // para hacerlo, pueden hacer uso de otras clases (si es necesario),
    // pero la corrección del ejercicio será automática en base a este
    // método que está acá
    public String ganadores(List<Carta[] > jugadas){
        System.out.println("Cantidad de jugadas: " + jugadas.size());
        for (Carta[] mano : jugadas) {
            System.out.println("JUGADA ======================");
            for (Carta c : mano) {
                System.out.println(c.valorPalo());
                    }
                }
        return "0";
    }

    public static void main(String[] args) {

        Carta carta1 = new Carta("AA");
        Carta carta2 = new Carta("AA"); 
        Carta carta3 = new Carta("AA");
        Carta carta4 = new Carta("AA");
        Carta carta5 = new Carta("AA");
        Carta carta6 = new Carta("AA");
        Carta carta7 = new Carta("AA"); 
        Carta carta8 = new Carta("AA");
        Carta carta9 = new Carta("AA");
        Carta carta10 = new Carta("AA");
        Poker partida = new Poker();
        String [] valores = {"A","2","3","4","5","6","7","8","9","T","J","Q","K",};
        String [] palos = {"D","S","C","H",};
        String [] cartas = new String [10];
        int control = 100;//Variable para controlar el ingreso de cartas repetidas
        Carta [] mano = new Carta[]{carta1,carta2,carta3,carta4,carta5,};
        Carta [] mano2 = new Carta[]{carta6,carta7,carta8,carta9,carta10,};



        while (control > 10) {
            for (int i = 0; i < mano.length; i++) {
                mano2[i].valor = mano2[i].valor.concat(valores[(int)Math.floor(Math.random()*(11-0+1)+0)]);
                mano[i].palo = mano[i].palo.concat(palos[(int)Math.floor(Math.random()*(2-0+1)+0)]);
            }
            for (int i = 0; i < mano2.length; i++) {
                mano2[i].valor = mano2[i].valor.concat(valores[(int)Math.floor(Math.random()*(11-0+1)+0)]);
                mano2[i].palo = mano2[i].palo.concat(palos[(int)Math.floor(Math.random()*(2-0+1)+0)]);
            }
            for (int i = 0; i < mano.length; i++) {
                for (int j = 0; j < mano.length; j++) {
                    if (mano[i].valorPalo().equals(mano[j].valorPalo())) {
                        control++;
                    }
                }
            }
            for (int i = 0; i < mano2.length; i++) {
                for (int j = 0; j < mano2.length; j++) {
                    if (mano2[i].valorPalo().equals(mano2[j].valorPalo())) {
                        control++;
                    }
                }
            }
        }
        control = 0;
        //Le paso los valores con el metodo del profe
        for (int i = 0; i < mano.length; i++) {
            partida.setValues(mano[i].valorPalo());
        }
        //Condicional para imprimir los resultados solo si no se encontraron cartas repetidas
        if(control == 5){
            if ((partida.controlValor(partida.getValue())== "") && (partida.controlPalos(partida.getSuit()) == "" )) {
                System.out.println("CARTA ALTA");
            }else{
                //Dejo a modo de comentario para posibles comprobaciones o controles
                // System.out.println(partida.getSuit());
                // System.out.println(partida.getValue());
                System.out.print("Sus cartas son: [");
                for (int i = 0; i < mano.length; i++) {
                    System.out.print(mano[i] + ",");
                }
                System.out.print("]\n");
                System.out.println("Jugada: " + partida.controlValor(partida.getValue()) + " " + partida.controlPalos(partida.getSuit()));
            }
        }else{
            System.out.println("Jugada invalidas: Se encontraron cartas iguales, por favor intente de nuevo");
        }
    }
}
